DIR

  Main.s

"
ASSEMBLE
fOrtho  EQU     0          * These two flags set the
fBigQ   EQU     1          * behavior, see WORMS.DOC
RPL

::
CK1NOLASTWD
CK&DISPATCH1 real
 ::
 DUP %1 %< IT              * Negative or zero number
  SETSIZEERR               * of worms not allowed
 COERCE
 NULL$ OVER

ASSEMBLE                   * Jazz does not support
        CON(5)  =DOBINT    * conditional RPL assem-
 IF fBigQ                  * bly, so we have to do
        CON(5)  256*4+4    * it the hard way
 ELSE                      * For an explanation of
        CON(5)  16*4+2     * the actual values, see
 ENDIF                     * WORMS.DOC
RPL

 #*

ASSEMBLE
        CON(5)  =DOBINT
 IF fOrtho
        CON(5)  4*4
 ELSE
        CON(5)  8*4
 ENDIF
RPL

 #+ EXPAND
 RECLAIMDISP TURNMENUOFF   * Clear ABUFF and resize
 ZEROZERO #82 #0 LINEON    * it to 131 x 64
 ZEROZERO #0 #3F LINEON    * Then draw a rectangle
 #82 #0 #82 #3F LINEON     * round the edges to make
 #0 #3F #82 #3F LINEON     * sure no worm crawls
                           * out of bounds.
 ABUFF ROT

 CODE
        INCLUDE Main.a
 ENDCODE
 TURNMENUON RECLAIMDISP    * Restore ABUFF size
 FLUSH DROP                * Empty key buffer
 ;
;
"


  Main.a

"
Main

 IF fBigQ                  * Define sQueue, the size
sQueue  EQU     4+256*4    * of one queue in nibbles
 ELSE                      * This value is used
sQueue  EQU     2+16*4     * later in the program
 ENDIF

 IF fOrtho
sWays   EQU     4*4        * Do the same for the
 ELSE                      * temporary ways area
sWays   EQU     8*4
 ENDIF

        INCLUDE SetupRg.a  * Init scratch regs
        INCLUDE Init.a     * Init all queues

        INTOFF             * Disable keyboard and
        ST=0    15         * I/O interrupts
        C=R3.F  A
        R4=C.F  A          * Start with worm m
mainlp  INCLUDE MoveW.a    * Move it
        C=R4.F  A
        LA(5)   sQueue     * Go to down one worm
        C=C-A   A
        R4=C.F  A
        A=R2.F  A
        ?A=C    A          * Have we done all?
        GOYES   +
        GOTO    mainlp
+       INCLUDE CkKey.a    * Any keys pressed?
        GONC    +
        C=R3.F  A
        R4=C.F  A
        GOTO    mainlp     * Move all worms again
+       ST=1    15         * Turn all interrupts
        INTON              * back on
        GOVLNG  =GETPTRLOOP

 IF fBigQ                  * Include all modules
        INCLUDE sBigQ.a    * that the program
 ELSE                      * uses. The code for
        INCLUDE sSmallQ.a  * queue handling are
 ENDIF                     * in two different
        INCLUDE sPix.a     * files
        INCLUDE sGo.a
"


  SetupRg.a

"
SetupRg GOSBVL  =POP#      * Pop off number of
        R2=A.F  A          * worms into R2
        C=DAT1  A
        LA(5)   20
        C=C+A   A          * R0 -> top left
        R0=C.F  A          * nibble of ABUFF
        D1=D1+  5
        D=D+1   A          * Drop ABUFF pointer
        GOSBVL  =SAVPTR
        C=DAT1  A
        LA(5)   10
        C=C+A   A
        R1=C.F  A          * R1 -> temp ways
        LA(5)   (sQueue)-(sWays)
        C=C-A   A          * Calculate position
        A=C     A          * of worm 0 queue
        AR2EX.F A          * R2 -> worm 0 queue
 IF fBigQ
        A=A+A   A          * If we are using big
        A=A+A   A          * queues, multiply
        C=C+A   A          * number of worms
        ASL     A          * with 256*4+4
        ASL     A
        C=C+A   A
 ELSE
        A=A+A   A          * If we are using
        C=C+A   A          * small queues,
        ASL     A          * multiply with
        A=A+A   A          * 16*4+2
        C=C+A   A
 ENDIF
        R3=C.F  A          * R3 -> worm m
"


  Init.a

"
Init    C=R3.F  A
        R4=C.F  A          * Start with worm m
initlp  C=R4.F  A
        D0=C               * D0 -> indices

 IF fBigQ
        LCHEX   0001       * Set write = 1,
        DAT0=C  4          * read = 0
        D0=D0+  4
 ELSE
        LCHEX   01
        DAT0=C  2
        D0=D0+  2
 ENDIF

        INCLUDE RPoint.a   * Generate random point
        DAT0=C  4          * and store at pos 0
        C=R4.F  A
        LA(5)   sQueue
        C=C-A   A
        R4=C.F  A          * Next worm
        A=R2.F  A
        ?A=C    A
        GOYES   +
        GOTO    initlp
+
"


  MoveW.a

"
MoveW   GOSUB   PeekQ      * Get worm head
        INCLUDE Ways.a     * Get all free ways
        ?B#0    P          * Were there any?
        GOYES   moveHd
        GOTO    tail

moveHd  INCLUDE RndWay.a   * Select one at random
        D=C     A
        GOSUB   PutQ       * Put it in the queue
        C=D     A
        GOSUB   SetP       * Set pixel on screen

full    GOSUB   SizeQ      * Check if queue is
 IF fBigQ                  * full. Because the size
        C=C-1   B          * is returned in C[P] or
 ELSE                      * C[B] depending on fBigQ
        C=C-1   P          * we must do different
 ENDIF                     * tests
        GOC     moveTl
        GOTO    exit
        
tail    GOSUB   SizeQ      * Check if there are than
 IF fBigQ                  * two pixels in the queue
        LAHEX   01
        ?C>A    B
        GOYES   moveTl
 ELSE
        LAHEX   1
        ?C>A    P
        GOYES   moveTl
 ENDIF
        GOTO    exit
        
moveTl  GOSUB   GetQ       * Get tail pos from queue
        GOSUB   ClrP       * Clear pixel on screen
        
exit
"


  Ways.a

"
Ways    A=R1.F  A
        D0=A               * D0 -> temp ways area
        B=0     A          * Way counter
        GOSUB   GoUp       * Up one pixel
        D=C     A
        GOSUB   TestP      * Pixel set on screen?
        C=D     A          * If so, carry is clr
        GONC    +
        DAT0=C  4          * Store pixel
        D0=D0+  4
        B=B+1   A          * Increase counter
+       GOSUB   GoLt
 IF 1-fOrtho               * If fOrtho is true then
        D=C     A          * we skip the pixel one
        GOSUB   TestP      * step up and to the
        C=D     A          * left
        GONC    +
        DAT0=C  4
        D0=D0+  4
        B=B+1   A
+
 ENDIF
        GOSUB   GoDn       * The pixel to the left
        D=C     A          * of the head is always
        GOSUB   TestP      * checked
        C=D     A
        GONC    +
        DAT0=C  4
        D0=D0+  4
        B=B+1   A
+       GOSUB   GoDn
 IF 1-fOrtho               * Rest is rather
        D=C     A          * trivial...
        GOSUB   TestP
        C=D     A
        GONC    +
        DAT0=C  4
        D0=D0+  4
        B=B+1   A
+
 ENDIF
        GOSUB   GoRt
        D=C     A
        GOSUB   TestP
        C=D     A
        GONC    +
        DAT0=C  4
        D0=D0+  4
        B=B+1   A
+       GOSUB   GoRt
 IF 1-fOrtho
        D=C     A
        GOSUB   TestP
        C=D     A
        GONC    +
        DAT0=C  4
        D0=D0+  4
        B=B+1   A
+
 ENDIF
        GOSUB   GoUp
        D=C     A
        GOSUB   TestP
        C=D     A
        GONC    +
        DAT0=C  4
        D0=D0+  4
        B=B+1   A
+
 IF 1-fOrtho
        GOSUB   GoUp
        D=C     A
        GOSUB   TestP
        C=D     A
        GONC    +
        DAT0=C  4
        D0=D0+  4
        B=B+1   A
+
 ENDIF
"


  sGo.a

"
GoUp    CSRC    W          * Shift out mask
        LA(3)   34         * Subtract offset
        C=C-A   X          * with 34 (one row)
        CSLC    W          * Shift back mask
        RTN
        
GoDn    CSRC    W          * Shift out mask
        LA(3)   34         * Add 34 (one row)
        C=C+A   X          * to offset
        CSLC    W          * Shift back mask
        RTN

GoLt    SB=0               * Shift mask one bit
        CSRB.F  P          * (pixel goes to the 
        ?SB=0              * left) and return if
        RTNYES             * all is OK
        CSRC    W          * The mask got shifted
        C=C-1   X          * out, so we decrement
        CSLC    W          * the offset and
        LCHEX   8          * reset the mask
        RTN

GoRt    C=C+C   P          * Shift mask one bit
        RTNNC              * (pixel goes to the
        CSRC    W          * right) and adjust the 
        C=C+1   X          * offset in case we got
        CSLC    W          * carry
        LCHEX   1
        RTN
"


  sSmallQ.a

"
* This is the implementation of the 16 pixel
* queue. The routines for the two types of
* queus were so different I decided to have
* two different files instead of using
* IF ... THEN ... ENDIF statements.

GetQ    C=R4.F  A          * Get the current queue
        C=C+1   A
        D0=C
        A=0     A
        A=DAT0  P          * A[A] = read index
        C=A     P
        C=C+1   P          * add one modulo 16
        DAT0=C  P          * new index
        A=A+A   A          * Multiply old index with
        A=A+A   A          * four (size of one entry)
        A=A+1   A          * and add one to skip past
        CD0EX              * the read index
        C=C+A   A
        D0=C
        C=DAT0  4          * Read the entry
        RTN
        
PutQ    RSTK=C             * Save pixel
        C=R4.F  A          * Current queue
        D0=C
        C=0     A
        C=DAT0  P
        A=C     A          * A[A] = write index
        C=C+1   P          * add one modulo 16
        DAT0=C  P          * new index
        A=A+A   A          * Multiply by four and
        A=A+1   A          * add two to skip past
        A=A+A   A          * both indices
        CD0EX
        C=C+A   A
        D0=C
        C=RSTK             * Pop of saved pixel
        DAT0=C  4          * Write it
        RTN

PeekQ   C=R4.F  A
        D0=C
        A=0     A          * A[A] = write index
        A=DAT0  P
        A=A-1   P          * Subtract one mod 16
        A=A+A   A          * and then multiply as
        A=A+A   A          * when writing. Also,
        A=A+1   A          * don't update index
        A=A+1   A
        C=C+A   A
        D0=C
        C=DAT0  4
        RTN

* Note: a return value of zero from SizeQ could
* mean both that the queue is empty and that it
* is full. Since in our implementation the
* queues never can become empty it always means
* that the queue is full.

SizeQ   C=R4.F  A
        D0=C
        C=DAT0  P          * C[P] = write index
        D0=D0+  1
        A=DAT0  P          * A[P] = read index
        C=C-A   P          * C[P] = size
        RTN
"


  sBigQ.a

"
* This is the second implementation of queues
* (with 256 entries). The code is very similar
* to the one in sSmallQ.a

GetQ    C=R4.F  A
        D0=C
        D0=D0+  2
        A=0     A
        A=DAT0  B
        C=A     B
        C=C+1   B
        DAT0=C  B
        A=A+A   A
        A=A+1   A
        A=A+A   A
        CD0EX
        C=C+A   A
        D0=C
        C=DAT0  4
        RTN
        
PutQ    RSTK=C
        C=R4.F  A
        D0=C
        C=0     A
        C=DAT0  B
        A=C     A
        C=C+1   B
        DAT0=C  B
        A=A+1   A
        A=A+A   A
        A=A+A   A
        CD0EX
        C=C+A   A
        D0=C
        C=RSTK
        DAT0=C  4
        RTN

PeekQ   C=R4.F  A
        D0=C
        A=0     A
        A=DAT0  B
        A=A-1   B
        A=A+1   A
        A=A+A   A
        A=A+A   A
        C=C+A   A
        D0=C
        C=DAT0  4
        RTN

SizeQ   C=R4.F  A
        D0=C
        C=DAT0  B
        D0=D0+  2
        A=DAT0  B
        C=C-A   B
        RTN
"


  sPix.a

"
* GotoP is the important routine here.
* Please note the simplicity of this module
* due to the special pixel representation used.

SetP    GOSUB   GotoP
        A=A!C   P
        DAT1=A  P
        RTN
        
ClrP    GOSUB   GotoP
        C=-C-1  P
        A=A&C   P
        DAT1=A  P
        RTN
        
TestP   GOSUB   GotoP      * TestP will return with
        A=A&C   P          * carry SET if the pixel
        ?A=0    P          * was CLEAR. Natural for
        RTNYES             * our uses, but rather
        RTN                * backwards.

GotoP   CSRC    W          * Shift out mask
        A=0     A
        A=C     X          * A[A] = offset
        C=R0.F  A          * R0[A] = top left pixel
        C=C+A   A          * of display. Add offset
        D1=C               * D1 -> wanted nybble
        CSLC    W          * Shift mask back again
        A=DAT1  P          * Read nybble
        RTN
"


  RndWay.a

"
* RndWay will select a way at "random" from the
* ones stored in the temp ways area. Requires
* the number of ways to choose from to be in B[A].
* There is no need to "randomize" to CRC by reading
* or writing extra data to memory, because this
* routine will be called between a lot of such
* calls.

RndWay  D1=(5)  =CRC       * Use CRC for randomness
        C=0     A
        C=DAT1  P          * One nybble suffices
        A=B     A
        GOTO    +          * These four rows
-       C=C-A   P          * calculates
+       ?C>=A   P          * C[P]=C[P] (mod A[P])
        GOYES   -
        A=R1.F  A          * R1->temp ways area
        C=C+C   A          * Multiply by four
        C=C+C   A
        A=A+C   A
        D1=A
        C=DAT1  4          * Read selected way
"


  RPoint.a

"
* Generates a random point by using the CRC. Must
* read extra data from memory inbetween reads from
* CRC to "randomize" it's value. The points will
* be in the intervals 0<x<130 and 0<y<63 because of
* the black border round the edges of the display.

RPoint  D1=(5)  =TIMER1    * Read misc data from
        A=DAT1  B          * memory
        D1=(5)  =CRC       * CRC is "random"
        C=0     A
        C=DAT1  B          * Add the values to
        C=C+A   B          * increase randomness
        LA(5)   62         * These lines
        GOTO    +          * calculates
-       C=C-A   A          * C[A]=C[A] (mod 62),
+       ?C>=A   A          * i.e. 0<=C[A]<=61
        GOYES   -
        C=C+1   A          * 0 < C[A] < 63
        C=C+C   A          * Multiply by 34 to
        D=C     A          * get nybble offset
        CSL     A
        D=D+C   A
        D1=(5)  =TIMER1    * Repeat procedure
        A=DAT1  B
        C=0     A
        D1=(5)  =CRC
        C=DAT1  B
        C=C+A   B
        LA(5)   129        * Now do
        GOTO    +          * C[A]=C[A] (mod 129),
-       C=C-A   A          * i.e. 0<=C[A]<=128
+       ?C>=A   A
        GOYES   -
        C=C+1   A          * 0 < C[A] < 130
        A=C     A
        CSRB.F  A          * C[A] = C[A] >> 2
        CSRB.F  A
        C=C+D   A          * Offset done, shift
        CSL     A          * it to correct pos
        LCHEX   3
        A=A&C   P          * A[P]=A[P] (mod 4)
        LCHEX   1          * Init mask
        A=A-1   P          * The usual pixelmask
        GOC     +          * code...
        C=C+C   P
        A=A-1   P
        GOC     +
        C=C+C   P
        A=A-1   P
        GOC     +
        C=C+C   P
+
"


  CkKey.a 

"
* Sets carry if NO keys were pressed

CkKey   LCHEX   1FF        * Scan all rows
        OUT=C   X
        GOSBVL  =CINRTN
        P=      3          * Check if C[4] was zero
        C=C-1   WP         * indicating no keys
        P=      0          * were pressed
"

END
